<?php
namespace Teknisa\FIN\Controllers;

use Teknisa\FIN\Controllers\TeknisaCrud;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\FIN\Services\Ger38200ImportacaoContasPagarService;

class Ger38200ImportacaoContasPagarController extends TeknisaCrud{
    
    
    /**
     * @param CrudService $crudService
     * @param ParameterBag $parameterBag
     * @param Environment $environment
     * @param Ger38200ImportacaoContasPagarController $ger38200ImportacaoContasPagarService
     */
    public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, Ger38200ImportacaoContasPagarService $ger38200ImportacaoContasPagarService){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->ger38200ImportacaoContasPagarService = $ger38200ImportacaoContasPagarService;
    }

    /**
     * Importação de Contas a Pagar - Web Service
     * @param Row $row
     * @param Response $response
     */
    public function importacaoContasPagar(Data $dataset, Response $response){
        try {
            $rows = $dataset->getDataSet()->getRows();
            $dados = $rows[0];
            
            $this->ger38200ImportacaoContasPagarService->importacaoContasPagar($dados);
            
            $response->addDataSet(new DataSet('importacaoContasPagar', ['success' => 'S']));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
}