<?php

namespace Teknisa\FIN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class  Rec57000RelatorioTitulosObservacaoLancamentoController{
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;

    public function __construct(ReportService $reportService, $dataSourceManager, $environment) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
    }

    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        
        $row = $request->getRow();
        $reportName = $row["__report_name"];
        
        $parametersRow = array (
            "CDEMPRESA"  => str_replace('_', ',', $row["CDEMPRESA"]),
            "CLIENTE" => str_replace('_', ',', $row["CLIENTE"]),
            "FORNECEDOR" => str_replace('_', ',', $row["FORNECEDOR"]),
            "CDFILIAL" => str_replace('_', ',', $row["CDFILIAL"]),
            "STATUS" => $row["STATUS"],
            "DTPERIODOINI" => $row["DTPERIODOINI"],
            "DTPERIODOFIN" => $row["DTPERIODOFIN"],
            "DTBAIXAINI" => $row["DTBAIXAINI"],
            "DTBAIXAFIN" => $row["DTBAIXAFIN"],
            "DTPERIOINIEMI" => $row["DTPERIOINIEMI"],
            "DTPERIOFIMEMI" => $row["DTPERIOFIMEMI"],
            "TPCONTAREC" => str_replace('_', ',', $row["TPCONTAREC"]),
            "TPCONTAPAG" => str_replace('_', ',', $row["TPCONTAPAG"]),
            "CDTPCREDBANC" => str_replace('_', ',', $row["CDTPCREDBANC"]),
            "CDTPDEBIBANC" => str_replace('_', ',', $row["CDTPDEBIBANC"]),
            "NRORG" =>  $this->nrorg,
            "__format" => $row["__FORMAT"]
        );

        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $response->addMessage(new DTO\Response\Message($birtURL));
    }
}