<?php
namespace Teknisa\FIN\Modules\ContaReceber\Services\Remessa\Banco;

use Geral\Entities\Contcorr;
use \Geral\Entities\Empresa;
use Financeiro\Util\Util;
use Teknisa\Libs\Util\DateUtil;
use Financeiro\Entities\Boletreceber;
use Geral\Entities\Licencauso;
use Geral\Entities\Endeclie;
use Geral\Entities\Cliente;
use Geral\Util\Ambiente;
use Geral\Entities\Filial;
use Teknisa\FIN\Modules\ContaReceber\Services\Remessa\GeraCnabService;

class GeraCnabCaixaService extends GeraCnabService{

    const CODIGO_BANCO = '104';
    const LOTE_SERVICO_HEADER = '0000';
    const LOTE_SERVICO_TRAILLER = '9999';
    const LOTE_SERVICO = '0001';
    const TIPO_REGISTRO = '0';
    const TIPO_REGISTRO_HEADER_LOTE = '1';
    const TIPO_REGISTRO_DETALHE = '3';
    const TIPO_REGISTRO_TRAILLER_LOTE = '5';
    const TIPO_REGISTRO_TRAILLER = '9';
    const VERSAO_ARQUIVO = '050';
    const VERSAO_ARQUIVO_LOTE = '030';
    const CODIGO_REMESSA = '1';
    const TIPO_OPERACAO = 'R';
    const TIPO_SERVICO = '01';
    const CODIGO_SEGMENTO_P = 'P';
    const CODIGO_SEGMENTO_Q = 'Q';
    const CODIGO_SEGMENTO_R = 'R';
    const CODIGO_MOEDA = '09';
    const CODIGO_BAIXA = '2';
    const CODIGO_DESCONTO = '0';
    const IDENTIFICACAO_TITULO = 'N';
    const ESPECIE_TITULO = '02';
    const TIPO_DOCUMENTO = '2';

    protected $cdfilial;

    public function geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont, $carteira = NULL, $contreg = NULL, $idtipcnabrec = NULL, $cdfilial, $contador = NULL){

        try {
            
            if (!is_dir($caminho))
                mkdir($caminho, "0777", true);
            $nmarquivo = $caminho . $nmarquivo;
            $file = fopen($nmarquivo, "w+");

            // CAMPO: Código do Banco
            // POSIÇÃO: 001 a 003
            // PICTURE: 9(3)
            $arquivo = self::CODIGO_BANCO;
            
            // CAMPO: Lote de Serviço
            // POSIÇÃO: 004 a 007
            // PICTURE: 9(4)
            $arquivo .= self::LOTE_SERVICO_HEADER;

            // CAMPO: Tipo de registro
            // POSIÇÃO: 008 a 008
            // PICTURE: 9(1)
            $arquivo .= self::TIPO_REGISTRO;

            // CAMPO: Uso exclusivo FEBRABAN
            // POSIÇÃO: 009 a 017
            // PICTURE: X(9)
            $arquivo = str_pad($arquivo, 17);

            // CAMPO: Tipo da inscrição da empresa
            // POSIÇÃO: 018 a 018
            // PICTURE: 9(1)
            /** @var $empresa Empresa */
            
            $empresa = Empresa::findOneByCdempresa($cdempresa);
            if ($empresa) {
                if ($empresa->getIdtpijurempr() == 'F')
                    $tipoInscricaoCedente = '1';
                else
                    $tipoInscricaoCedente = '2';
            }
            $arquivo .= $tipoInscricaoCedente;
            
            // CAMPO: Nº de inscrição da empresa
            // POSIÇÃO: 019 a 032
            // PICTURE: 9(14)
            
            if(!empty($cdfilial)) {
                $filial = Filial::findOneByCdfilial($cdfilial);
                $arquivo .= $filial->getNrinsjurfili();
            } else{
                $arquivo .= $empresa->getNrinsjurempr();
            }
            
            // if ($empresa){
            //     if(strlen($empresa->getNrinsjurempr()) < 14)
            //         throw new \Exception('Número de inscrição da empresa inválido.');
            //     else
            //         $arquivo .= $empresa->getNrinsjurempr();
            // }

            //CAMPO: Uso Exclusivo VAIXA
            //POSIÇÃO: 033 A 052
            //PICTURE: 9(20)
            $arquivo = str_pad($arquivo, 52, 0);

            /** @var $contcorr Contcorr */
            $contcorr = Contcorr::findOneByCdreducont($cdreducont);
            $agencia = substr($contcorr->getCdagencia(), 0, 4);
            // CAMPO: Agência mantenedora da conta
            // POSIÇÃO: 053 a 057
            // PICTURE: X(5)
            $arquivo .= str_pad($agencia, 5, '0', STR_PAD_LEFT);

            // CAMPO: Dígito verificador Agencia
            // POSIÇÃO: 058 a 058
            // PICTURE: X(1)
            if(strlen($contcorr->getCdagencia()) < 5)
                $arquivo .= 0;
            else{
                $dvagencia = substr($contcorr->getCdagencia(), -1);
                $arquivo .= $dvagencia;
            }

            //CAMPO: Uso Exclusiovo da Caixa
            //POSIÇÃO: 65 a 71
            //PICTURE; 9(7)
            $arquivo = str_pad($arquivo, 71, 0);

            //CAMPO: Uso Exclusiovo da Caixa
            //POSIÇÃO: 72 a 72
            //PICTURE: 9(1)
            $arquivo = str_pad($arquivo, 72, 0);

            // CAMPO: Nome da Empresa
            // POSIÇÃO: 073 a 0102
            // PICTURE: X(30)
            /** @var $empresa Empresa */
            $empresa = Empresa::findOneByCdempresa($cdempresa);
            
            if($cdfilial){
               $filial = Filial::findOneByCdfilial($cdfilial); 
               $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
               $nmrazsocemp = substr($nmrazsocemp, 0, 30);
               $arquivo .= str_pad($nmrazsocemp, 30);
            } else {
                $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
                $nmrazsocemp = substr($nmrazsocemp, 0, 30);
                $arquivo .= str_pad($nmrazsocemp, 30);
            }
            
            // if ($empresa) {
            //     $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
            //     $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            //     $arquivo .= str_pad($nmrazsocemp, 30);
            // }
            // else
            //     $arquivo = str_pad($arquivo, 102);

            // CAMPO: Nome do Banco
            // POSIÇÃO: 103 a 0132
            // PICTURE: X(30)
            $arquivo .= str_pad('CAIXA ECONOMICA FEDERAL', 30);

            // CAMPO: Uso exclusivo FEBRABAN
            // POSIÇÃO: 133 a 142
            // PICTURE: X(10)
            $arquivo = str_pad($arquivo, 142);

            // CAMPO: Código Remessa
            // POSIÇÃO: 143 a 0143
            // PICTURE: 9(01)
            $arquivo .= self::CODIGO_REMESSA;

            // CAMPO: Data da geração do arquivo
            // POSIÇÃO: 144 a 151
            // PICTURE: 9(08)
            $now = DateUtil::getDataAtual();
            $data = DateUtil::getDia($now) . DateUtil::getMes($now) . substr(DateUtil::getAno($now), -2);
            $arquivo .= Util::campoCnabValido($data);

            // CAMPO: Hora da geração do arquivo
            // POSIÇÃO: 152 a 0157
            // PICTURE: X(06)
            $now = DateUtil::getDataAtual();
            $horaGeracao = $now->format('His');
            $arquivo .= $horaGeracao;

            // CAMPO: Número Seqüencial do Arquivo
            // POSIÇÃO: 158 a 163
            // PICTURE: X(06)
            $arquivo .= substr($nrseqremessarec, -6);

            // CAMPO: Versão do Arquivo
            // POSIÇÃO: 164 a 166
            // PICTURE: X(3)
            $arquivo .= self::VERSAO_ARQUIVO;

            // CAMPO: Densidade de gravação do arquivo
            // POSIÇÃO: 167 a 171
            // PICTURE: X(5)
            $arquivo = str_pad($arquivo, 171, '0');

            // CAMPO: Reservado para o Banco
            // POSIÇÃO: 172 a 191
            // PICTURE: X(20)
            $arquivo = str_pad($arquivo, 191);

            // CAMPO: Reservado para a Empresa
            // POSIÇÃO: 192 a 211
            // PICTURE: X(20)
            if($contcorr && $contcorr->getIdfascnabrec() == 'T')
                $arquivo .= str_pad('REMESSA-TESTE', 20);
            else
                $arquivo .= str_pad('REMESSA-PRODUCAO', 20);

            // CAMPO: Brancos
            // POSIÇÃO: 212 a 240
            // PICTURE: X(29)
            $arquivo = str_pad($arquivo, 240) . "\r\n";

            //Grava a variavel arquivo no arquivo texto
            fprintf($file, "%s", $arquivo);
            fclose($file);
        } catch (\Exception $e) {

        }
    }


    public function geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnabrec, $cdreducont, $carteira = NULL, $cdfilial){

        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO;

        // CAMPO: Tipo de Registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_HEADER_LOTE;

        // CAMPO: Tipo de Operação
        // POSIÇÃO: 009 a 009
        // PICTURE: X(1)
        $arquivo .= self::TIPO_OPERACAO;

        // CAMPO: Tipo de Serviço
        // POSIÇÃO: 010 a 011
        // PICTURE: 9(2)
        $arquivo .= self::TIPO_SERVICO;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 012 a 013
        // PICTURE: X(2)
        // ** 00 ao invés de brancos por causa da sol. 0000137916 **
        $arquivo = str_pad($arquivo, 13, '0');

        // CAMPO: Versão do Arquivo
        // POSIÇÃO: 14 a 16
        // PICTURE: X(3)
        $arquivo .= self::VERSAO_ARQUIVO_LOTE;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 17 A 17
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 17);

        // CAMPO: Tipo da inscrição da empresa
        // POSIÇÃO: 018 a 018
        // PICTURE: 9(1)
        /** @var $empresa Empresa */
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        if ($empresa) {
            if ($empresa->getIdtpijurempr() == 'F')
                $tipoInscricaoCedente = '1';
            else
                $tipoInscricaoCedente = '2';
        }
        $arquivo .= $tipoInscricaoCedente;

        // CAMPO: Nº de inscrição da empresa
        // POSIÇÃO: 019 a 033
        // PICTURE: 9(15)
        
        if ($cdfilial){
            $filial = Filial::findOneByCdfilial($cdfilial);
            $arquivo .= str_pad($filial->getNrinsjurfili(), 15, '0', STR_PAD_LEFT);
        } else {
            $arquivo .= str_pad($empresa->getNrinsjurempr(), 15, '0', STR_PAD_LEFT);
        }
        

        /** @var $contcorr Contcorr */
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        //CAMPO: Código Convênio no Banco
        //POSIÇÃO: 034 A 39
        //PICTURE: 9(6)
        //CONTEÚDO: CCCCCC
        if($contcorr->getCdcedenteban()){
            $arquivo .= $contcorr->getCdcedenteban();
        }
        else
            $arquivo = str_pad($arquivo, 39, 0);

        // CAMPO: Uso exclusivo CAIXA
        // POSIÇÃO: 40 A 53
        // PICTURE: X(14)
        $arquivo = str_pad($arquivo, 53);

        $agencia = $contcorr->getCdagencia();
        if(strlen($agencia) >= 5){
            $agencia = substr($agencia, 0, 4);
        }
        // CAMPO: Agência mantenedora da conta
        // POSIÇÃO: 054 a 058
        // PICTURE: X(5)
        $arquivo .= str_pad($agencia, 5, '0', STR_PAD_LEFT);

        // CAMPO: DV da Agência
        // POSIÇÃO: 059 a 059
        // PICTURE: X(4)
        if(strlen($contcorr->getCdagencia()) < 5)
            $arquivo .= 0;
        else{
            $dvagencia = substr($contcorr->getCdagencia(), -1);
            $arquivo .= $dvagencia;
        }

        // CAMPO: Código do Cedente
        // POSIÇÃO: 060 a 065
        // PICTURE: 9(6)
        // CONTEUDO: CCCCCC
        $cdcedente = substr($contcorr->getCdcedenteban(), 0, 6);
        $arquivo .= str_pad($cdcedente, 6, '0', STR_PAD_LEFT);

        //CAMPO: Código do Modelo Personalizado
        //POSIÇÃO: 66 a 72
        //PICTURE: 9(7)
        $arquivo = str_pad($arquivo, 72, 0);

        //CAMPO: Uso Exclusivo CAIXA
        //POSIÇÃO: 73 a 73
        //PICTURE: 9(1)
        $arquivo = str_pad($arquivo, 73, 0);

        // CAMPO: Nome da Empresa
        // POSIÇÃO: 074 a 0103
        // PICTURE: X(30)
        /** @var $empresa Empresa */
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        
        if ($cdfilial){
            $filial = Filial::findOneByCdfilial($cdfilial);
            $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        } else {
            $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        }
        
        // if ($empresa) {
        //     $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
        //     $nmrazsocemp = substr($nmrazsocemp, 0, 30);
        //     $arquivo .= str_pad($nmrazsocemp, 30);
        // }
        // else
        //     $arquivo = str_pad($arquivo, 103);

        // CAMPO: Mensagem 1
        // POSIÇÃO: 104 a 0143
        // PICTURE: X(40)
        $arquivo = str_pad($arquivo, 143);

        // CAMPO: Mensagem 2
        // POSIÇÃO: 144 a 0183
        // PICTURE: X(40)
        $arquivo = str_pad($arquivo, 183);

        // CAMPO: Número Remessa/ Retorno
        // POSIÇÃO: 184 a 191
        // PICTURE: 9(8)
        $arquivo .= substr($nrseqremessarec, -8);

        // CAMPO: Data de Gravação REMESSA/RETORNO
        // POSIÇÃO: 192 a 199
        // PICTURE: 9(8)
        $now = DateUtil::getDataAtual();
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Data do Crédito
        // POSIÇÃO: 200 a 207
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 207, '0');

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 208 a 240
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);

    }
    public function geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec,
                                         $nrcnabrec, $idoperacao, $cdagenciacnab, $cdcontacorrente, $cdcontcorrcobranca, $nossonumero,
                                         $idtipocobranca, $nrlanbolrec, $cdfilial, $dtvenbolrec, $valorfinalboleto, $valorpemobrec, $valormordiabrec,
                                         $valorpemulbrec, $valormultabrec, $valorfinalbrec, $cdcartcobbol, $cddiaprotbol, $cdreducont,
                                         $imprbol, $qtdiaprotbol, $contador = NULL
    ){
        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no lote
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);

        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: X(1)
        $arquivo .= self::CODIGO_SEGMENTO_P;

        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);

        // CAMPO: Código do Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        if($idoperacao == 'E')
            $arquivo .= '02';    // Exclusão
        elseif($idoperacao == 'I')
            $arquivo .= '01';    // Inclusão
        else
            $arquivo .= '06';    // Alteração

        //Armazena a agência na variável
        /** @var $contcorr Contcorr */
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        $agencia = $contcorr->getCdagencia();
        if(strlen($agencia) >= 5){
            $agencia = substr($agencia, 0, 4);
            $dvagencia = substr($arquivo, -1);
        }

        //CAMPO: Agência Mantedora da Conta + DV
        //POSIÇÃO: 018 a 23
        //PICTURE: 9(06)
        $arquivo .= str_pad($agencia, 5, '0', STR_PAD_LEFT);
        if(strlen($contcorr->getCdagencia()) < 5)
            $arquivo .= '0';
        else
            $arquivo .= $dvagencia;

        //CAMPO: Codigo do cedente
        //POSIÇÃO: 024 a 29
        //PICTURE: 9(12)
        //CONTEUDO: CCCCCC
        $cdcedente = substr($contcorr->getCdcedenteban(), 0, 6);
        $arquivo .= str_pad($cdcedente, 6, '0', STR_PAD_LEFT);

        //CAMPO: Uso Exclusivo da CAIXA
        //POSIÇÃO: 030 a 37
        //PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 37, 0);

        //CAMPO: Uso Exclusivo da CAIXA
        //POSIÇÃO: 038 a 40
        //PICTURE: 9(3)
        $arquivo = str_pad($arquivo, 40, 0);

        //CAMPO: Uso exclusivo Caixa
        //POSIÇÃO: 041 a 42
        //PICTURE: 9(2)
        $arquivo .= substr($cdcartcobbol, 0, 2);

        // CAMPO: Identificação do título no banco
        // POSIÇÃO: 043 a 057
        // PICTURE: 9(15)
        if($imprbol == 'E'){
            if(!$nossonumero)
                $arquivo = str_pad($arquivo, 57, '0');
            else
                $arquivo .= "21" . str_pad($nossonumero, 13, '0', STR_PAD_LEFT);
        }
        else
            $arquivo = str_pad($arquivo, 57, '0');

        // CAMPO: Código da carteira
        // POSIÇÃO: 058 a 058
        // PICTURE: 9(1)
        if($idtipocobranca){
            if($idtipocobranca == '1'){
                $arquivo .= '1';
            }
            elseif($idtipocobranca == '3')
                $arquivo .= '3';
            elseif($idtipocobranca == '4')
                $arquivo .= '4';
        }

        // CAMPO: Forma de cadastramento do título 1- Com registro 2- Sem registro
        // POSIÇÃO: 059 a 059
        // PICTURE: 9(1)
        /** @var $boleto Boletreceber */
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        $this->cdfilial = $boleto->getCdfilial();
        if($boleto && $boleto->getIdformcadbrec())
            $arquivo .= $boleto->getIdformcadbrec();
        else
            $arquivo .= '1';

        // CAMPO: Tipo de Documento
        // POSIÇÃO: 060 a 060
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_DOCUMENTO; // 1- Tradicional 2- Escritural

        // CAMPO: Identificação da emissão do Bloqueto 1- Banco Emite 2- Cliente Emite
        // POSIÇÃO: 061 a 061
        // PICTURE: 9(1)
        if($imprbol == 'B')
            $arquivo .= '1';
        else
            $arquivo .= '2';

        // CAMPO: Identificação da distribuição 1- Banco Distribui 2- Cliente Distribui
        // POSIÇÃO: 062 a 062
        // PICTURE: 9(1)
        if($imprbol == 'B')
            $arquivo .= '2';
        else
            $arquivo .= '0';

        // CAMPO: Número do Documento de cobrança
        // POSIÇÃO: 063 a 073
        // PICTURE: X(11)
        /** @var $entityBoleto \Financeiro\Repositories\Boletreceber */
        $entityBoleto = Boletreceber::getRepository();
        $duplicata = $entityBoleto->getDuplicata($cdfilial, $nrlanbolrec);

        if (!$duplicata[0]['DUPLICATA'])
            $arquivo .= str_pad($nrlanbolrec, 11, '0');
        else {
            $arquivo .= str_pad(substr($duplicata[0]['DUPLICATA'], -8), 8, '0', STR_PAD_LEFT) . '/' . str_pad($duplicata[0]['NRPARCELA'], 2, '0', STR_PAD_LEFT);
        }

        // CAMPO: Uso Exclusivo Caixa
        // POSIÇÃO: 074 a 077
        // PICTURE: X(4)
        $arquivo = str_pad($arquivo, 77);

        // CAMPO: Data de vencimento do título
        // POSIÇÃO: 078 a 085
        // PICTURE: 9(8)
        $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
        $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Valor do título
        // POSIÇÃO: 086 a 100
        // PICTURE: 9(13)V9(2)
        $vrfinabolrec = str_pad(($valorfinalboleto * 100), 15, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($vrfinabolrec);

        // CAMPO: Agência cobradora
        // POSIÇÃO: 101 a 105
        // PICTURE: 9(5)
        $arquivo = str_pad($arquivo, 105, '0');

        // CAMPO: Dígito verificador
        // POSIÇÃO: 106 a 106
        // PICTURE: X(1)
        $arquivo .= '0';

        // CAMPO: Espécie do título
        // POSIÇÃO: 107 a 108
        // PICTURE: 9(2)
        $arquivo .= self::ESPECIE_TITULO;

        // CAMPO: Identificação de título aceito ou não aceito
        // POSIÇÃO: 109 a 109
        // PICTURE: X(1)
        $arquivo .= self::IDENTIFICACAO_TITULO;

        // CAMPO: Data de emissão do título
        // POSIÇÃO: 110 a 117
        // PICTURE: 9(8)
        $now = DateUtil::getDataAtual();
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Código de Juros de Mora
        // POSIÇÃO: 118 a 118
        // PICTURE: 9(1)
        if($valormordiabrec == 0)
            $arquivo .= 3;
        else
            $arquivo .= 1;

        // CAMPO: Data de Juros de Mora
        // POSIÇÃO: 119 a 126
        // PICTURE: 9(8)
        $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
        $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
        $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
        $arquivo .= Util::campoCnabValido($data);

        // CAMPO: Valor de mora por dia de atraso
        // POSIÇÃO: 127 a 141
        // PICTURE: 9(13)V9(2)
        if($valormordiabrec == 0)
            $arquivo = str_pad($arquivo, 141, '0');
        else{
            $vrmordiabrec = str_pad(($valormordiabrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= Util::campoCnabValido($vrmordiabrec);
        }

        // CAMPO: Código do Desconto
        // POSIÇÃO: 142 a 142
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_DESCONTO;

        // CAMPO: Data de Desconto
        // POSIÇÃO: 143 a 150
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 150, '0');

        // CAMPO: Valor do Desconto
        // POSIÇÃO: 151 a 165
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 165, '0');

        // CAMPO: Valor do I.O.F.
        // POSIÇÃO: 166 a 180
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 180, '0');

        // CAMPO: Valor do Abatimento
        // POSIÇÃO: 181 a 195
        // PICTURE: 9(13)V9(2)
        $arquivo = str_pad($arquivo, 195, '0');

        // CAMPO: Identificação do Título na Empresa
        // POSIÇÃO: 196 a 220
        // PICTURE: X(25)
        $arquivo .= str_pad($cdfilial . $nrlanbolrec, 25);

        // CAMPO: Código para Protesto
        // POSIÇÃO: 221 a 221
        // PICTURE: 9(1)
        if(!$cddiaprotbol)
            $arquivo .= '3';
        else
            $arquivo .= $cddiaprotbol;

        // CAMPO: Quantidade de dias para Protesto
        // POSIÇÃO: 222 a 223
        // PICTURE: 9(2)
        if(!$qtdiaprotbol)
            $arquivo .= '00';
        else
            $arquivo .= $qtdiaprotbol;

        // CAMPO: Código para Baixa/Devolução
        // POSIÇÃO: 224 a 224
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_BAIXA;

        // CAMPO: Prazo para Baixa/Devolução
        // POSIÇÃO: 225 a 227
        // PICTURE: 9(3)
        $arquivo = str_pad($arquivo, 227, '0');

        // CAMPO: Código da moeda
        // POSIÇÃO: 228 a 229
        // PICTURE: 9(2)
        $arquivo .= self::CODIGO_MOEDA;

        // CAMPO: Uso Exclusivo CAIXA
        // POSIÇÃO: 230 a 239
        // PICTURE: X(11)
        $arquivo = str_pad($arquivo, 239, 0);

        // CAMPO: Uso Exclusivo FEBRABAN/CNAB
        // POSIÇÃO: 240 A 240
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }

    public function geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $cdcliente, $idoperacao, $cdempresa, $cdfilial, $nrlanbolrec, $contador = NULL){

        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no arq.
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);

        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: X(1)
        $arquivo .= self::CODIGO_SEGMENTO_Q;

        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);

        // CAMPO: Código do Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        if($idoperacao == 'E')
            $arquivo .= '02';     //Exclusão
        elseif($idoperacao == 'I')
            $arquivo .= '01';     //Inclusão
        else
            $arquivo .= '06';     //Alteração

        /** @var $entityLicencaUso \Geral\Repositories\Licencauso */
        $entityLicencaUso = Licencauso::getRepository();

        $licencauso = $entityLicencaUso->getLicencaUso($cdfilial, $nrlanbolrec);
        if($licencauso){
            if($licencauso[0]['IDTPIJURLUSO'] == 'F')
                $tipoSacado = '1'; //CPF
            else
                $tipoSacado = '2'; //CNPJ

            if($licencauso[0]['NRINSJURLUSO'])
                $nrinsjur = $licencauso[0]['NRINSJURLUSO'];
            if($licencauso[0]['NRCEPLUSO'])
                $nrcep = $licencauso[0]['NRCEPLUSO'];

            $nmclie = $licencauso[0]['NMFANTLUSO'];
            $dsendeclie = $licencauso[0]['DSENDELUSO'];
            $nmbairro = $licencauso[0]['NMBAIRLUSO'];
            $nmmunicipio = $licencauso[0]['NMMUNICIPIO'];
            $sgestado = $licencauso[0]['SGESTADO'];
        }
        else{
            /** @var $entityEndeClie \Geral\Repositories\Endeclie */
            $entityEndeClie = Endeclie::getRepository();
            /** @var $boleto Boletreceber */
            $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
            /** @var $cliente Cliente */
            $cliente = Cliente::findOneByCdclienteAndNrorg($boleto->getCdcliente(), $nrorg);

            $endeclie = $entityEndeClie->getEndeClie($cdcliente);

            if($cliente->getIdtpijurclie() == 'F')
                $tipoSacado = '1'; //CPF
            else
                $tipoSacado = '2'; //CNPJ

            if($cliente->getNrinsjurclie())
                $nrinsjur = $cliente->getNrinsjurclie();
            if(isset($endeclie[0]['NRCEPCLIE']))
                $nrcep = $endeclie[0]['NRCEPCLIE'];
            else
                $nrcep = '00000000';

            $nmclie = $cliente->getNmrazsocclie();
            $dsendeclie = $endeclie[0]['DSENDECLIE'];
            $nmbairro = $endeclie[0]['NMBAIRCLIE'];
            $nmmunicipio = $endeclie[0]['NMMUNICIPIO'];
            $sgestado = $endeclie[0]['SGESTADO'];

        }

        // CAMPO: Código de inscrição/Sacado ('1' = CPF, '2' = CNPJ)
        // POSIÇÃO: 018 a 018
        // PICTURE: 9(1)
        $arquivo .= $tipoSacado;

        // CAMPO: Nº de inscrição do sacado (CPF/CGC)
        // POSIÇÃO: 019 a 033
        // PICTURE: 9(15)
        $arquivo .= Util::campoCnabValido(str_pad($nrinsjur, 15, '0', STR_PAD_LEFT));

        // CAMPO: Nome do sacado
        // POSIÇÃO: 034 a 073
        // PICTURE: X(40)
        $nomecliente = substr(Util::campoCnabValido($nmclie), 0, 40);
        $arquivo .= str_pad($nomecliente, 40);

        // CAMPO: Logradouro (Endereço do sacado (cliente))
        // POSIÇÃO: 074 a 113
        // PICTURE: X(36)
        $enderecoCliente = substr(Util::campoCnabValido($dsendeclie), 0, 40);
        $arquivo .= str_pad($enderecoCliente, 40);

        // CAMPO: Bairro do sacado
        // POSIÇÃO: 114 a 128
        // PICTURE: X(18)
        $bairro = substr(Util::campoCnabValido($nmbairro), 0, 15);
        $arquivo .= str_pad($bairro, 15);

        // CAMPO: C.E.P. do sacado
        // POSIÇÃO: 129 a 136
        // PICTURE: 9(8)
        $arquivo .= Util::campoCepTel($nrcep);

        // CAMPO: Cidade do sacado
        // POSIÇÃO: 137 a 151
        // PICTURE: X(15)
        $municipio = substr(Util::campoCnabValido($nmmunicipio), 0, 15);
        $arquivo .= str_pad($municipio, 15);

        // CAMPO: Estado do sacado
        // POSIÇÃO: 152 a 153
        // PICTURE: X(2)
        $arquivo .= Util::campoCnabValido(Util::campoCnabValido($sgestado));

        // CAMPO: Código de inscrição do sacador ou avalista
        // POSIÇÃO: 154 a 154
        // PICTURE: 9(1)
        $arquivo = str_pad($arquivo, 154, '0');

        // CAMPO: Nº de inscrição do sacador ou avalista
        // POSIÇÃO: 155 a 169
        // PICTURE: 9(15)
        $arquivo = str_pad($arquivo, 169, '0');

        // CAMPO: Nome do sacador ou avalista
        // POSIÇÃO: 170 a 209
        // PICTURE: X(40)
        $arquivo = str_pad($arquivo, 209);

        // CAMPO: Uso exclusivo FEBRABAN/Código do Banco correspondente
        // POSIÇÃO: 210 a 212
        // PICTURE: X(3)
        $arquivo = str_pad($arquivo, 212);

        // CAMPO: Uso exclusivo FEBRABAN/Nosso Número do Banco correspondente
        // POSIÇÃO: 213 a 232
        // PICTURE: X(20)
        $arquivo = str_pad($arquivo, 232);

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 233 a 240
        // PICTURE: X(8)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    public function geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $dtvenbolrec, $valorpemulbrec, $nrlanbolrec, $valormultabrec, $contador = NULL){

        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO;

        // CAMPO: Identificação do registro
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_DETALHE;

        // CAMPO: Nº seq. do reg. no arq.
        // POSIÇÃO: 009 a 013
        // PICTURE: 9(5)
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);

        // CAMPO: Código do Segmento
        // POSIÇÃO: 014 a 014
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_SEGMENTO_R;

        // CAMPO: Brancos
        // POSIÇÃO: 015 a 015
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 15);

        // CAMPO: Código de Movimento
        // POSIÇÃO: 016 a 017
        // PICTURE: 9(2)
        if($idoperacao == 'E')
            $arquivo .= '02';     //Exclusão
        elseif($idoperacao == 'I')
            $arquivo .= '01';     //Inclusão
        else
            $arquivo .= '06';     //Alteração

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 018 a 065
        // PICTURE: 9(48)
        $arquivo = str_pad($arquivo, 65);

        // CAMPO: Código da multa
        // POSIÇÃO: 066 a 066
        // PICTURE: 9(1)
        if($valormultabrec != 0)
            $arquivo .= '1';
        elseif($valorpemulbrec != 0)
            $arquivo .= '2';
        else
            $arquivo .= '0';

        // CAMPO: Data da multa
        // POSIÇÃO: 067 a 074
        // PICTURE: 9(8)
        if($valormultabrec == 0 && $valorpemulbrec == 0)
            $arquivo = str_pad($arquivo, 74, '0');
        else{
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
        }

        // CAMPO: Valor / percentual
        // POSIÇÃO: 075 a 089
        // PICTURE: 9(15)
        if($valorpemulbrec == 0){
            if($valormultabrec == 0)
                $arquivo = str_pad($arquivo, 89, '0');
            else{
                $vrmultabrec = str_pad(($valormultabrec * 100), 15, "0", STR_PAD_LEFT);
                $arquivo .= Util::campoCnabValido($vrmultabrec);
            }
        }
        else{
            $vrpemulbrec = str_pad(($valorpemulbrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= Util::campoCnabValido($vrpemulbrec);
        }

        // CAMPO: Informação do banco ao sacado
        // POSIÇÃO: 090 a 099
        // PICTURE: 9(10)
        $arquivo = str_pad($arquivo, 99);

        // CAMPO: Mensagem 3
        // POSIÇÃO: 100 a 179
        // PICTURE: 9(80)
        /** @var $boleto Boletreceber */
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $this->cdfilial);
        if($boleto && $boleto->getTxmensbolbol()){
            $mensagem = substr(Util::campoCnabValido($boleto->getTxmensbolbol()), 0, 80);
            $arquivo .= str_pad($mensagem, 80);
        }

        // CAMPO: Mensagem 4
        // POSIÇÃO: 100 a 179
        // PICTURE: 9(80)
        $arquivo = str_pad($arquivo, 179);

        // CAMPO: Código de desconto 2
        // POSIÇÃO: 180 a 240
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);

    }
    public function GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco, $contreg = NULL){

        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO;

        // CAMPO: Identificação do Arquivo
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_TRAILLER_LOTE;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 009 a 017
        // PICTURE: X(9)
        $arquivo = str_pad($arquivo, 17);

        // CAMPO: Quantidade de registros no lote
        // POSIÇÃO: 018 a 023
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($contreg, 6, "0", STR_PAD_LEFT));

        //Simples
        // CAMPO: Quantidade de títulos em cobrança
        // POSIÇÃO: 024 a 029
        // PICTURE: 9(6)
        //stLinha := stLinha + Ajusta(InttoStr(stCartSimp), 6);
        $arquivo = str_pad($arquivo, 29, '0');

        // CAMPO: Valor total dos títulos em carteira
        // POSIÇÃO: 030 a 46
        // PICTURE: 9(15)(02)
        //stLinha:= stLinha + VirgDeciAssu(FormatFloat('#0.00', doVrCartSimp), 17);
        $arquivo = str_pad($arquivo, 46, '0');

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 047 a 69
        // PICTURE: 9(23)
        $arquivo = str_pad($arquivo, 69, '0');

        //Caucionada
        // CAMPO: Quantidade de títulos em cobrança
        // POSIÇÃO: 070 a 075
        // PICTURE: 9(6)
        //stLinha := stLinha + Ajusta(InttoStr(stCartCauci), 6);
        $arquivo = str_pad($arquivo, 75, '0');

        // CAMPO: Valor total dos títulos em carteira
        // POSIÇÃO: 076 a 92
        // PICTURE: 9(15)(02)
        //stLinha:= stLinha + VirgDeciAssu(FormatFloat('#0.00', doVrCartCauci), 17);
        $arquivo = str_pad($arquivo, 92, '0');

        //Descontada
        // CAMPO: Quantidade de títulos em cobrança
        // POSIÇÃO: 093 a 098
        // PICTURE: 9(6)
        //stLinha := stLinha + Ajusta(InttoStr(stCartDesc), 6);
        $arquivo = str_pad($arquivo, 98, '0');

        // CAMPO: Valor total dos títulos em carteira
        // POSIÇÃO: 099 a 115
        // PICTURE: 9(15)(02)
        //stLinha:= stLinha + VirgDeciAssu(FormatFloat('#0.00', doVrCartDesc), 17);
        $arquivo = str_pad($arquivo, 115, '0');

        // CAMPO: Valor total dos títulos em carteira
        // POSIÇÃO: 0116 a 240
        // PICTURE: X(125)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);

    }
    public function GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco, $contlote = NULL, $contreg = NULL, $cdreducont = NULL){

        if (!is_dir($caminho))
            mkdir($caminho, "0777", true);
        $nmarquivo = $caminho . $nmarquivo;
        $file = fopen($nmarquivo, "a+");

        // CAMPO: Código do Banco
        // POSIÇÃO: 001 a 003
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;

        // CAMPO: Lote de Serviço
        // POSIÇÃO: 004 a 007
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_SERVICO_TRAILLER;

        // CAMPO: Identificação do Arquivo
        // POSIÇÃO: 008 a 008
        // PICTURE: 9(1)
        $arquivo .= self::TIPO_REGISTRO_TRAILLER;

        // CAMPO: Uso exclusivo FEBRABAN
        // POSIÇÃO: 009 a 017
        // PICTURE: X(9)
        $arquivo = str_pad($arquivo, 17);

        // CAMPO: Quantidade de lotes do arquivo
        // POSIÇÃO: 018 a 023
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($contlote, 6, "0", STR_PAD_LEFT));

        // CAMPO: Quantidade de registros do arquivo
        // POSIÇÃO: 024 a 029
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($contreg, 6, "0", STR_PAD_LEFT));

        // CAMPO: Brancos
        // POSIÇÃO: 030 a 240
        // PICTURE: X(211)
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);

    }
    public function geraTransacao($caminho, $nmarquivo,$nrorg, $cdempresa, $cdcartcobbol, $cdagencia, $cdcontcorr, $cdfilial,
                                  $nrlanbolrec, $vrpemobrec, $idimprboleto, $cdnosnumrec, $dtvenbolrec, $cdins1cobbol,
                                  $qtdiaprotbol, $vrmordiabrec, $vrfinalbrec, $idopecnabrec, $vrpemulbrec, $idtpijurclie,
                                  $nrinsjurclie, $cdcliente, $cdins2cobbol, $contreg = NULL, $idtipcnabrec = null, $idfilialcnabrec, $cddiaprotbol = NULL, $contador = NULL,$cdreducont,$cdbanco){}

    protected function calculaDv($codigo){
        $base = 2;
        $soma = 0;
        $contador = strlen($codigo);
        for($i=1; $i<=strlen($codigo); $i++){
            $contador--;
            $numero = intval(substr($codigo, $contador, 1));
            $soma += ($numero * $base);
            $base++;
            if($base > 9)
                $base = 2;
        }

        $resto = $soma % 11;
        $dv = 11 - $resto;

        if($dv > 9)
            return 0;
        else
            return $dv;
    }
}