function Pag12200_AdiantamentosDisponiveis_Controller(General, ScreenService, templateManager, ZhFilterPreferences) {
	
	this.setReadSelect = function(fieldNative, widgetFiltro, nameField){
		var field = widgetFiltro.getField(nameField);
		if(fieldNative.value() === 'L'){
			field.readOnly = false;
			field.validations = {"required": true};
			field.reload();
		} else {
			field.setValue(null);
			delete field.validations;
			field.readOnly = true;
			if (field.widget.currentRow.$error) {
        		field.widget.currentRow.$error[nameField] = [];
    		}
    		field.reload();
		}
	};

	this.checaDisponibilidadePag = function(field, valor){
		if(field.value() === 'N' && valor > 0){
			field.setValue('S');
			ScreenService.showMessage('Operação bloqueada! Adiantamento já foi utilizado.');
		}
	};
	
	this.filter = function(widget) {
		var rowFilter = {
			'TPCDFORNECED': 'T',
			'TPCDFILIORIG': 'T',
			'TPCDFILILANC': 'T',
			'TPFORMAPAG': 'T',
			'TPCDTPCTPAGAR': 'T',
			'STATUS': 'T'
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
		ZhFilterPreferences.openFilterWidget(widget, rowFilter);
	};

	this.AjustaFiltro = function(rowFilter){
		var widget = templateManager.container.getWidget('pag12200_adiantamentos_disponiveis_grid');
		var pos = 0;
		var deletePos = null;
		widget.dataSourceFilter.forEach(function(filter) {
			switch(filter.name){
				case 'DOCINICIAL': filter.value = (rowFilter.DOCINICIAL) ? rowFilter.DOCINICIAL : null;
					break;
				case 'DOCFINAL': filter.value = (rowFilter.DOCFINAL) ? rowFilter.DOCFINAL : null;
					break;
				case 'CDFORNECED': filter.value = (rowFilter.TPCDFORNECED == 'L') ? rowFilter.CDFORNECED.join('_') : '';
					break;
				case 'TPCDFORNECED': filter.value = rowFilter.TPCDFORNECED;
					break;
				case 'CDFILIORIG': filter.value = (rowFilter.TPCDFILIORIG == 'L') ? rowFilter.CDFILIORIG.join('_') : '';
					break;
				case 'TPCDFILIORIG': filter.value = rowFilter.TPCDFILIORIG;
					break;
				case 'CDFILILANC': filter.value = (rowFilter.TPCDFILILANC == 'L') ? rowFilter.CDFILILANC.join('_') : '';
					break;
				case 'TPCDFILILANC': filter.value = rowFilter.TPCDFILILANC;
					break;
				case 'FORMAPAG': filter.value = (rowFilter.TPFORMAPAG == 'L') ? rowFilter.FORMAPAG.join('_') : '';
					break;
				case 'TPFORMAPAG': filter.value = rowFilter.TPFORMAPAG;
					break;
				case 'CDTPCTPAGAR': filter.value = (rowFilter.TPCDTPCTPAGAR == 'L') ? rowFilter.CDTPCTPAGAR.join('_') : '';
					break;
				case 'TPCDTPCTPAGAR': filter.value = rowFilter.TPCDTPCTPAGAR;
					break;
				case 'DATAINI': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.start : null;
					break;
				case 'DATAFIN': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.end : null;
					break;
				case 'STATUS': filter.value = rowFilter.STATUS;
					break;
				case 'DATA': deletePos = pos;
					break;
			}
			pos++;
		});
		
		delete rowFilter.NMFANTFORN;
		delete rowFilter.NMFILIAL;
		delete rowFilter.NMFILIAL2;
		delete rowFilter.NMTPBAIXAPAG;
		delete rowFilter.DSTPCTPAGAR;
		
		if (deletePos){
			widget.dataSourceFilter.splice(deletePos, 1);
		}
	};

	this.setRequired = function(widget, nmf1, nmf2){
		var field1 = widget.getField(nmf1);
		var field2 = widget.getField(nmf2);
		if(field1.value() || field2.value()){
			field1.validations.required = true;
			field2.validations.required = true;
		} else {
			delete field1.validations.required;
			delete field2.validations.required;
			if (widget.currentRow.$error) {
        widget.currentRow.$error[nmf1] = [];
        widget.currentRow.$error[nmf2] = [];
      }
		}
	};
	
    this.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var cdtpctpagar = widget.getField('DSTPCTPAGAR');
        
        cdtpctpagar.setValue("");
        cdtpctpagar.dataSourceFilter[1].value = cdempresa;
        cdtpctpagar.reload();
    };
    
    this.filtroCompensacao = function(widget){
    	var nrlanctonf = templateManager.container.getWidget('pag12200_adiantamentos_disponiveis_grid').currentRow.NRLANCTONF;
    	var nrseqvenpag = templateManager.container.getWidget('pag12200_adiantamentos_disponiveis_grid').currentRow.NRSEQVENPAG;
    	var nrparcelapag = templateManager.container.getWidget('pag12200_adiantamentos_disponiveis_grid').currentRow.NRPARCELAPAG;
    	var cdfilial = templateManager.container.getWidget('pag12200_adiantamentos_disponiveis_grid').currentRow.CDFILIAL;
    	
    	widget.dataSourceFilter = [
    			{
	                "name": "NRLANCTONF",
	                "operator": "=",
	                "value": nrlanctonf
    			},
    			{
	                "name": "NRSEQVENPAG",
	                "operator": "=",
	                "value": nrseqvenpag
    			},
    			{
	                "name": "NRPARCELAPAG",
	                "operator": "=",
	                "value": nrparcelapag
    			},
    			{
	                "name": "CDFILIAL",
	                "operator": "=",
	                "value": cdfilial
    			}
    		];
    		widget.reload();
    	
    };

}

Configuration(function (ContextRegister) {
	ContextRegister.register('Pag12200_AdiantamentosDisponiveis_Controller', Pag12200_AdiantamentosDisponiveis_Controller);
});