function Pag20000_ControleRateioContasPagar_Controller(ZhFilterPreferences, templateManager, ScreenService, General) {
    
    /**
     * Variáveis de Inicialização
     **/
     
    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */

    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.filterPrincipal = function (widget, preference) {
        
        widget.dataSourceFilter.forEach(function(filter) {
            switch (filter.name) {
                case 'CDEMPRESA':
                    filter.value = preference.FILTER_ROW.CDEMPRESA;
                    break;
                case 'OPERADORLANC':
                    filter.value = preference.FILTER_ROW.CDOPERACTPG ? preference.FILTER_ROW.CDOPERACTPG : 'T';
                    break;
                case 'DTVENCINI':
                    filter.value = preference.FILTER_ROW.DTATUAVENPAG.start;
                    break;
                case 'DTVENCFIN':
                    filter.value = preference.FILTER_ROW.DTATUAVENPAG.end;
                    break;
                /*titulo*/    
                case 'TPCONTA':
                        if(preference.FILTER_ROW.CDTPCTPAGAR === undefined || preference.FILTER_ROW.CDTPCTPAGAR.length === 0){
                            filter.value = 'T';
                        }else{
                            filter.value = preference.FILTER_ROW.CDTPCTPAGAR ? preference.FILTER_ROW.CDTPCTPAGAR.join("_"): '';
                        }
                    break;
                case 'IDSTATPAG':
                    var idstatpag = '';
                        if (preference.FILTER_ROW.IDSTATPAG == 'A'){
                            idstatpag = ['A'];
                        } else if (preference.FILTER_ROW.IDSTATPAG == 'B'){
                            idstatpag = ['B'];
                        } else {
                            idstatpag = 'T';
                        }
                        filter.value = idstatpag;
                    break;
                case 'VRORIGINI':
                    filter.value = preference.FILTER_ROW.VRORIGINI ? preference.FILTER_ROW.VRORIGINI : null;
                    break;
                case 'VRORIGFIN':
                    filter.value = preference.FILTER_ROW.VRORIGFIN ? preference.FILTER_ROW.VRORIGFIN : null;
                    break;
                case 'VRORIG':
                    filter.value = (preference.FILTER_ROW.VRORIGINI && preference.FILTER_ROW.VRORIGFIN) ? null : 'T';
                    break;
                case 'VRLIQUINI':
                    filter.value = preference.FILTER_ROW.VRLIQUINI ? preference.FILTER_ROW.VRLIQUINI : null;
                    break;
                case 'VRLIQUFIN':
                    filter.value = preference.FILTER_ROW.VRLIQUFIN ? preference.FILTER_ROW.VRLIQUFIN : null;
                    break;
                case 'VRATUAL':
                    filter.value = (preference.FILTER_ROW.VRLIQUINI && preference.FILTER_ROW.VRLIQUFIN) ? null : 'T';
                    break;
                /*documento*/    
                case 'FORNECEDOR':
                        if(preference.FILTER_ROW.CDFORNECED === undefined || preference.FILTER_ROW.CDFORNECED.length === 0){
                            filter.value = 'T';
                        }else{
                            filter.value = preference.FILTER_ROW.CDFORNECED ? preference.FILTER_ROW.CDFORNECED.join("_"):'';
                        }
                    break;
                case 'FILIORIG':
                        if(preference.FILTER_ROW.CDFILIORIG === undefined || preference.FILTER_ROW.CDFILIORIG.length === 0){
                            filter.value = 'T';
                        }else{
                            filter.value = preference.FILTER_ROW.CDFILIORIG ? preference.FILTER_ROW.CDFILIORIG.join("_"): '';
                        }
                    break;
                case 'FILILANC':
                        if(preference.FILTER_ROW.CDFILILANC === undefined || preference.FILTER_ROW.CDFILILANC.length === 0){
                            filter.value = 'T';
                        }else{
                            filter.value = preference.FILTER_ROW.CDFILILANC ? preference.FILTER_ROW.CDFILILANC.join("_"): '';
                        }
                    break;
                    
                case 'NRNOTAFISCINI':
                    filter.value = preference.FILTER_ROW.NRNOTAFISCINI ? preference.FILTER_ROW.NRNOTAFISCINI : null;
                    break;
                case 'NRNOTAFISCFIN':
                    filter.value = preference.FILTER_ROW.NRNOTAFISCFIN ? preference.FILTER_ROW.NRNOTAFISCFIN : null;
                    break;
                case 'TNRNOTAFISCAL':
                    filter.value = (preference.FILTER_ROW.NRNOTAFISCINI && preference.FILTER_ROW.NRNOTAFISCFIN) ? null : 'T';
                    break;
                    
                case 'VRDOCUINI':
                    filter.value = preference.FILTER_ROW.VRDOCUINI ? preference.FILTER_ROW.VRDOCUINI : null;
                    break;
                case 'VRDOCUFIN':
                    filter.value = preference.FILTER_ROW.VRDOCUFIN ? preference.FILTER_ROW.VRDOCUFIN: null;
                    break;
                case 'TVRDOCUMENTO':
                    filter.value = (preference.FILTER_ROW.VRDOCUINI && preference.FILTER_ROW.VRDOCUFIN) ? null : 'T';
                    break;
                    
                case 'DTEMISSAOINI':
                    filter.value = preference.FILTER_ROW.DTEMISSAO ? preference.FILTER_ROW.DTEMISSAO.start : '';
                    break;
                case 'DTEMISSAOFIN':
                    filter.value = preference.FILTER_ROW.DTEMISSAO ? preference.FILTER_ROW.DTEMISSAO.end : '';
                    break;
                case 'TEMISSAO':
                    if(preference.FILTER_ROW.DTEMISSAO){
                        if(preference.FILTER_ROW.DTEMISSAO.start){
                            filter.value = null;
                        }else {
                            filter.value =  'T';
                        }
                    }
                    else {
                        filter.value = 'T';
                    }
                    break;
                
                case 'DTENTRADAINI':
                    filter.value = preference.FILTER_ROW.DTENTRSAID ? preference.FILTER_ROW.DTENTRSAID.start : '';
                    break;
                case 'DTENTRADAFIN':
                    filter.value = preference.FILTER_ROW.DTENTRSAID ? preference.FILTER_ROW.DTENTRSAID.end : '';
                    break;
                case 'TSAIDA':
                    if(preference.FILTER_ROW.DTENTRSAID){
                        if(preference.FILTER_ROW.DTENTRSAID.start){
                            filter.value = null;
                        }else {
                            filter.value =  'T';
                        }
                    } else {
                        filter.value = 'T';
                    }
                    break;
                    
                case 'STATUS':
                    var status = '';
                        if (preference.FILTER_ROW.IDSTATUS == 'A'){
                            status = ['A'];
                        } else if (preference.FILTER_ROW.IDSTATUS == 'V'){
                            status = ['V'];
                        } else {
                            status = 'A_E';
                        }
                        filter.value = status;
    	           break;
                case 'IDBLOQNFFIN':
                    var idbloqnffin = '';
                        if (preference.FILTER_ROW.IDBLOQNFFIN == 'L'){
                            idbloqnffin = ['L'];
                        } else if (preference.FILTER_ROW.IDBLOQNFFIN == 'B'){
                            idbloqnffin = ['B'];
                        } else {
                            idbloqnffin = 'T';
                        }
                        filter.value = idbloqnffin;
                    break;
            }
        });
        delete preference.FILTER_ROW.DTATUAVENPAG;
        preference.CUSTOM_FILTER_ROW = {};
    };
    
    self.filteRateioPadrao = function(widget, preference){
        var nrlanctonf = templateManager.container.getWidget('pag20000_controle_rateio_contas_pagar').currentRow.NRLANCTONF;
    	var nrseqvenpag = templateManager.container.getWidget('pag20000_controle_rateio_contas_pagar').currentRow.NRSEQVENPAG;
    	var nrparcelapag = templateManager.container.getWidget('pag20000_controle_rateio_contas_pagar').currentRow.NRPARCELAPAG;
    	var cdfilial = templateManager.container.getWidget('pag20000_controle_rateio_contas_pagar').currentRow.CDFILIAL;
    	
    	widget.dataSourceFilter = [
    			{
	                "name": "NRLANCTONF",
	                "operator": "=",
	                "value": nrlanctonf
    			},
    			{
	                "name": "NRSEQVENPAG",
	                "operator": "=",
	                "value": nrseqvenpag
    			},
    			{
	                "name": "NRPARCELAPAG",
	                "operator": "=",
	                "value": nrparcelapag
    			},
    			{
	                "name": "CDFILIAL",
	                "operator": "=",
	                "value": cdfilial
    			}
    		];
    		widget.reload();
    };
    
    self.addRateio = function(widget){
        widget.newRow();
        widget.getAction('saveEdit').isVisible = false;
        widget.getAction('save').isVisible = true;
        self.validarCampo();
    };
    
    self.controlaActions = function(){
        templateManager.container.getWidget('rateioCliente_grid').getAction('saveEdit').isVisible = true;
        templateManager.container.getWidget('rateioCliente_grid').getAction('save').isVisible = false;
    }; 
    
    self.validarCampo = function(){
        var widget = templateManager.container.getWidget('rateioCliente_grid');
        
        if(widget.getField('CDCLIENTE').value()){
            widget.getField('CDCLIENTE').readOnly = true;
        }else{
            widget.getField('CDCLIENTE').readOnly = false;
        }
        templateManager.updateTemplate();
    };
    
    self.salvar = function(widget){
        var rateioGrid = templateManager.container.getWidget("rateioCliente_grid");
        var rateioPadrao = templateManager.container.getWidget('rateioTitulo_grid');
        var gridPrincipal = templateManager.container.getWidget("pag20000_controle_rateio_contas_pagar");
        var cdCliente = rateioGrid.currentRow.CDCLIENTE;
        var vrRatccctpag = rateioGrid.currentRow.VRRATCCCTPAG;
        var nmRazsocclie = rateioGrid.currentRow.NMRAZSOCCLIE;
        
        
        
        var rateioTotal = 0;
        rateioGrid.dataSource.data.forEach(function(valor){
            rateioTotal += parseFloat(valor.VRRATCCCTPAG);
        });

        if(rateioTotal > rateioPadrao.currentRow.VRRATCCCTPAG && rateioTotal > gridPrincipal.currentRow.VRATUAPAG){
            ScreenService.showMessage("Operação bloqueada. Total do(s) rateio(s) difere do valor total em "+((rateioTotal-rateioPadrao.currentRow.VRRATCCCTPAG).formatFloat()));
            return;
        }else{
            rateioGrid.getField('CDCLIENTE').setValue(cdCliente);
            rateioGrid.getField('VRRATCCCTPAG').setValue(vrRatccctpag);
            rateioGrid.getField('NMRAZSOCCLIE').setValue(nmRazsocclie);
            
            gridPrincipal.view();
            ScreenService.goBack();
            widget.getAction('saveAlt').isVisible = true;
        }
    };
    
    self.salvarAlteracoes = function(widget){
        var rateioGrid = templateManager.container.getWidget("rateioCliente_grid");
    //    var rateioPadrao = templateManager.container.getWidget('rateioTitulo_grid');
        var gridPrincipal = templateManager.container.getWidget("pag20000_controle_rateio_contas_pagar");

        var vrTotalRateio = 0;
        rateioGrid.dataSource.data.forEach(function(valor){
            vrTotalRateio += parseFloat(valor.VRRATCCCTPAG);
        });

        if(vrTotalRateio < gridPrincipal.currentRow.VRATUAPAG || vrTotalRateio > gridPrincipal.currentRow.VRATUAPAG){
            ScreenService.showMessage("A soma dos rateios deve ser igual ao valor da conta");
            return;
        } else {
            
            General.callRestEngine("fin_contaPagar#/salvarRateio", 'Row', rateioGrid.dataSource.data).then(function(result) {
                if(result.dataset.salvarRateio.success == 'S'){
                    ScreenService.showMessage('Registro salvo com sucesso.');
                    rateioGrid.reload();
                }else{
                    ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
                }
            }).catch(function(error){
                        ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
            });
        }
        
    };
    
    self.editarRateioValor = function(widget){
        var rateioPadrao = templateManager.container.getWidget('rateioTitulo_grid');
        var rateioGrid = templateManager.container.getWidget("rateioCliente_grid");
        var gridPrincipal = templateManager.container.getWidget("pag20000_controle_rateio_contas_pagar");
        var cdCliente = rateioGrid.currentRow.CDCLIENTE;
        var vrRatccctpag = rateioGrid.currentRow.VRRATCCCTPAG;
        
        var cdfiratctpag = rateioPadrao.currentRow.CDFIRATCTPAG;
        var cdfilial = rateioPadrao.currentRow.CDFILIAL;
        var nrlanctonf = rateioPadrao.currentRow.NRLANCTONF;
        var nrseqvenpag = rateioPadrao.currentRow.NRSEQVENPAG;
        var nrparcelapag = rateioPadrao.currentRow.NRPARCELAPAG;
        
        var filter = [
            {
                "CDCLIENTE" : cdCliente
            },
            {
                "NRLANCTONF": nrlanctonf
            },
            {
                "CDFILIAL": cdfilial
            },
            {
                "NRSEQVENPAG": nrseqvenpag
            },
            {
                "NRPARCELAPAG": nrparcelapag
            },
            {
                "CDFIRATCTPAG" : cdfiratctpag
            },
            
            {
                "VRRATCCCTPAG": vrRatccctpag
            }
            
        ];
        var vrTotalRateio = 0;
        
        rateioGrid.dataSource.data.forEach(function(valor){
            vrTotalRateio += parseFloat(valor.VRRATCCCTPAG);
        });
        
       // var rateioTotal = vrTotalRateio; // Recebe o valor do rateio digitado e faz a verificacao se é maior ou nao
        
        if (vrTotalRateio > gridPrincipal.currentRow.VRATUAPAG) {
            ScreenService.showMessage("Operação bloqueada. Total do(s) rateio(s) difere do valor total em "+((vrTotalRateio-gridPrincipal.currentRow.VRATUAPAG).formatFloat()));
            return;
        } else {
            General.callRestEngine("fin_contaPagar#/updateRateio", 'Row', filter).then(function(result) {
                    if(result.dataset.updateRateio.success == 'S'){
                        ScreenService.showMessage('Registro atualizado com sucesso.');
                        ScreenService.closeSwipe();
                        rateioGrid.reload();
                    }else{
                        ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
                    }
            }).catch(function(error){
                        ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
            });
        }
    };
    
    self.deleteRateio = function(widget){
        var rateioPadrao = templateManager.container.getWidget('rateioTitulo_grid');
        var rateioGrid = templateManager.container.getWidget("rateioCliente_grid");
        var cdCliente = rateioGrid.currentRow.CDCLIENTE;
        var vrRatccctpag = rateioGrid.currentRow.VRRATCCCTPAG;
        
        var cdfiratctpag = rateioPadrao.currentRow.CDFIRATCTPAG;
        var cdfilial = rateioPadrao.currentRow.CDFILIAL;
        var nrlanctonf = rateioPadrao.currentRow.NRLANCTONF;
        var nrseqvenpag = rateioPadrao.currentRow.NRSEQVENPAG;
        var nrparcelapag = rateioPadrao.currentRow.NRPARCELAPAG;
        
        var dados = [
            {
                "CDCLIENTE" : cdCliente
            },
            {
                "NRLANCTONF": nrlanctonf
            },
            {
                "CDFILIAL": cdfilial
            },
            {
                "NRSEQVENPAG": nrseqvenpag
            },
            {
                "NRPARCELAPAG": nrparcelapag
            },
            {
                "CDFIRATCTPAG" : cdfiratctpag
            },
            
            {
                "VRRATCCCTPAG": vrRatccctpag
            }
            
        ];
        General.callRestEngine("fin_contaPagar#/deleteRateio", 'Row', {'DELETADO':dados,"DATA": rateioGrid.dataSource.data}).then(function(result) {
                if(result.dataset.deleteRateio.success == 'S'){
                    ScreenService.showMessage('Registro deletado com sucesso.');
                    ScreenService.closeSwipe();
                    rateioGrid.reload();
                }else{
                    ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
                }
        }).catch(function(error){
                    ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
        });
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Pag20000_ControleRateioContasPagar_Controller', Pag20000_ControleRateioContasPagar_Controller);
});