function Bco32000_RelatorioEntradasSaidasCaixa_Controller(ZhFilterPreferences) {
    
    /**
     * Variáveis de Inicialização
     **/
     
    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */

    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.filterRelatorio = function(widget, preference, rowFilter){
        var cdEmpresa = preference.FILTER_ROW.CDEMPRESA;
        var cdClassfina = preference.FILTER_ROW.CDCLASSFINA;
        var cdFilial = preference.FILTER_ROW.CDFILIAL;
        var tcdFilial = preference.FILTER_ROW.TCDFILIAL;
        var tipoFluxo = preference.FILTER_ROW.TIPOFLUXO;
        var dtMovFluxo = preference.FILTER_ROW.DTMOVFLUXO;
        var saldoIni = preference.FILTER_ROW.SALDOINICIAL;
        var status = preference.FILTER_ROW.STATUS;
        var fluxo;

        if(cdFilial === undefined || cdFilial.length === 0){
            tcdFilial = 'T';
        }else{
            tcdFilial = '';
        }
        if(Array.isArray(tipoFluxo)){
            fluxo = tipoFluxo.join("_");
        }else{
            fluxo = tipoFluxo;
        }
                    
        widget.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA':
                    filtro.value = cdEmpresa?cdEmpresa.join("_"): 'T';
                break;
                case 'CDCLASSFINA':
                    filtro.value = cdClassfina?cdClassfina.join("_"):'T';
                break;
                case 'CDFILIAL':
                    filtro.value = cdFilial?cdFilial.join("_"):'';
                break;
                case 'TCDFILIAL':
                    filtro.value = tcdFilial?tcdFilial:'';
                break;
                case 'TIPOFLUXO':
                    filtro.value = tipoFluxo?fluxo:'';
                break;
                case 'STATUS':
                    filtro.value = status?status:'T';
                    break;
                case 'SALDOINICIAL':
                    filtro.value = saldoIni?saldoIni:'';
                    break;
                case 'DTINICIAL':
                    filtro.value = dtMovFluxo.start;
                break;
                case 'DTFINAL':
                    filtro.value = dtMovFluxo.end;
                break;
            }
        });
        delete preference.FILTER_ROW.DTMOVFLUXO;
        preference.CUSTOM_FILTER_ROW = {};
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Bco32000_RelatorioEntradasSaidasCaixa_Controller', Bco32000_RelatorioEntradasSaidasCaixa_Controller);
});